
#ifndef TCPPROTOCOLONFIGURATOR_H_
#define TCPPROTOCOLONFIGURATOR_H_

#include <Base_Configurator.h>
#include <TCP_Protocol.h>

namespace inaf::oasbo::ConnectionProtocols{

class TCPProtocolConfigurator : public BaseConfigurator{

public:
	TCPProtocolConfigurator(int argc, char **argv);
	TCPProtocolConfigurator();

	void setIp(std::string val){this->params["ip"] = val;}
	void setPort(int val){this->params["port"] = std::to_string(val);}

	std::map<std::string,std::string> getParams(){return this->params;}
	std::string getIp(){return this->params["ip"];}
	int getPort(){return stoi(this->params["port"]);}

	BaseProtocol * createProtocol();
	ConnectionProtocols::TCPProtocol * createTCPProtocol();


	void printConfiguration(){
		std::string confStr = "TCP Protocol Configuration:\n" + this->toString();
		std::cout << confStr << std::endl;
	}

};
}
#endif
