#include <TCP_Protocol.h>
using namespace inaf::oasbo::ConnectionProtocols;

TCPProtocolBuilder::TCPProtocolBuilder() {
	this->reset();
}

TCPProtocolBuilder::TCPProtocolBuilder(std::string ip, int port) {
	this->protocol = new TCPProtocol(ip, port);

}

TCPProtocolBuilder::~TCPProtocolBuilder() {
	delete protocol;
}

void TCPProtocolBuilder::reset() {
	this->protocol = new TCPProtocol();
}

TCPProtocolBuilder* TCPProtocolBuilder::configFrom(Configurators::BaseConfigurator *conf) {
	conf->readConfigFromSource(config_target);
	std::map<std::string, std::string> params = conf->getConfig();

	std::string key = config_target+"_"+ip_key;
	if (params.count(key) > 0)
		protocol->ip = params[key];

	key = config_target+"_"+port_key;
	if (params.count(port_key) > 0)
		protocol->port = std::stoi(params[key]);
	return this;
}

TCPProtocolBuilder* TCPProtocolBuilder::setIp(std::string ip) {
	protocol->ip = ip;
	return this;
}

TCPProtocolBuilder* TCPProtocolBuilder::setPort(int port) {
	protocol->port = port;
	return this;
}

TCPProtocol* TCPProtocolBuilder::getProtocol() {
	TCPProtocol *result = this->protocol;
	this->reset();
	return result;
}
